# vmware_host_powerstate – Manages power states of host systems in vCenter

New in version 2.6.

- Synopsis
- Requirements
- Parameters
- Examples
- Return Values
- Status

## Synopsis

- This module can be used to manage power states of host systems in given vCenter infrastructure.
- User can set power state to ‘power-down-to-standby’, ‘power-up-from-standby’, ‘shutdown-host’ and ‘reboot-host’.
- State ‘reboot-host’, ‘shutdown-host’ and ‘power-down-to-standby’ are not supported by all the host systems.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6
- PyVmomi

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
cluster_name string |  | Name of the cluster from which all host systems will be used. This is required parameter if `esxi_hostname` is not specified.
esxi_hostname string |  | Name of the host system to work with. This is required parameter if `cluster_name` is not specified.

force
boolean

Choices:
- no ←
- yes

This parameter specify if the host should be proceeding with user defined powerstate regardless of whether it is in maintenance mode.
If `state` set to `reboot-host` and `force` as `true`, then host system is rebooted regardless of whether it is in maintenance mode.
If `state` set to `shutdown-host` and `force` as `true`, then host system is shutdown regardless of whether it is in maintenance mode.
If `state` set to `power-down-to-standby` and `force` to `true`, then all powered off VMs will evacuated.
Not applicable if `state` set to `power-up-from-standby`.

hostname string |  | The hostname or IP address of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_HOST` will be used instead. Environment variable support added in Ansible 2.6.
password string |  | The password of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_PASSWORD` will be used instead. Environment variable support added in Ansible 2.6. aliases: pass, pwd
port integer added in 2.5 | Default: 443 | The port number of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_PORT` will be used instead. Environment variable support added in Ansible 2.6.
proxy_host string added in 2.9 |  | Address of a proxy that will receive all HTTPS requests and relay them. The format is a hostname or a IP. If the value is not specified in the task, the value of environment variable `VMWARE_PROXY_HOST` will be used instead. This feature depends on a version of pyvmomi greater than v6.7.1.2018.12
proxy_port integer added in 2.9 |  | Port of the HTTP proxy that will receive all HTTPS requests and relay them. If the value is not specified in the task, the value of environment variable `VMWARE_PROXY_PORT` will be used instead.

state
string

Choices:
- power-down-to-standby
- power-up-from-standby
- shutdown-host ←
- reboot-host

Set the state of the host system.

timeout integer | Default: 600 | This parameter defines timeout for `state` set to `power-down-to-standby` or `power-up-from-standby`. Ignored if `state` set to `reboot-host` or `shutdown-host`. This parameter is defined in seconds.
username string |  | The username of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_USER` will be used instead. Environment variable support added in Ansible 2.6. aliases: admin, user

validate_certs
boolean

Choices:
- no
- yes ←

Allows connection when SSL certificates are not valid. Set to `false` when certificates are not trusted.
If the value is not specified in the task, the value of environment variable `VMWARE_VALIDATE_CERTS` will be used instead.
Environment variable support added in Ansible 2.6.
If set to `yes`, please make sure Python >= 2.7.9 is installed on the given machine.

## Examples

    - name: Set the state of a host system to reboot
      vmware_host_powerstate:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        validate_certs: no
        esxi_hostname: '{{ esxi_hostname }}'
        state: reboot-host
      delegate_to: localhost
      register: reboot_host

    - name: Set the state of a host system to power down to standby
      vmware_host_powerstate:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        validate_certs: no
        esxi_hostname: '{{ esxi_hostname }}'
        state: power-down-to-standby
      delegate_to: localhost
      register: power_down

    - name: Set the state of all host systems from cluster to reboot
      vmware_host_powerstate:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        validate_certs: no
        cluster_name: '{{ cluster_name }}'
        state: reboot-host
      delegate_to: localhost
      register: reboot_host

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
result dictionary | always | metadata about host system's state Sample: {'esxi01': {'msg': "power down 'esxi01' to standby", 'error': ''}}

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Abhijeet Kasurde (@Akasurde)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.